/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Collections;
using System.Drawing;

namespace symmetry
{
	/// <summary>
	/// Summary description for Constraints.
	/// </summary>
	public class Constraints
	{
		
		Recognizer2 recog = new Recognizer2();
		private  Array  twoFoundObjects = new Array[2];
		private int odstopanjeMedKotoma = 10;
		private int odstopanjeOdKota = 30;
		
		public Constraints()
		{
			// TODO: Add constructor logic here
			//
		}

		public int klasificirajObjekt(Stroke1 st,Pen p,Graphics g)
		{
			
			
			int i = 0;
			int stKotov = 0;
			int indexZadnjegaKota = 0;
			
			Point p1,p2,p3;
			Point[] r1 = new Point[4];
			ArrayList idexiTock = new ArrayList();
			p1 = new Point(0,0);
			p3 = new Point(0,0);
		

			r1[0] = new Point();
			r1[1] = new Point();
			r1[2] = new Point();


		
		//	r1[0].X = (st.returnElement(0)).X;
		//	r1[0].Y = (st.returnElement(0)).Y;

			idexiTock.Add(st.returnElement(0));
		
       			

			for(i = 1;i< st.numberOfPoints()-1;i++)
			{
				p2 = st.returnElement(i);
						

				if(Math.Abs(st.returnRecognitionAngle(i) - 90)<= this.odstopanjeOdKota)
				{
					if(stKotov < 3)
					{
						
						if(aliSoTockeNaCrti(indexZadnjegaKota,i,st,g))
						{
						//	r1[stKotov+1].X = p2.X;
						//	r1[stKotov+1].Y = p2.Y;
							idexiTock.Add(p2);
							indexZadnjegaKota = i;

						}
						else 
							break;


						
					}
					stKotov++;
				
				}


			}
			
		//	System.Console.WriteLine("------------------------------------");

			if(stKotov == 3)
			{
			//	System.Console.WriteLine(indexZadnjegaKota+"..."+st.numberOfPoints());
				if(!aliSoTockeNaCrti(indexZadnjegaKota,st.numberOfPoints()-1,st,g)){
					 stKotov = -1;	//povecamo stevilo kotov zato da ne prepoznamo objekta
					}
					
						
				
			}

			if(stKotov == 3 && st.vrniVrsto())
			{
			
		
						Pravokotnik rec = new Pravokotnik();
						rec.addPoints(r1[0],r1[1],r1[2]);
						p.Color = Color.Red;
						rec.narisiPrav(p,g);
						p.Color = Color.Black;

						
						st.clearStroke();
					//	st.addPoint(r1[0],0);
					//	st.addPoint(r1[1],0);
					//	st.addPoint(r1[2],0);
				
						st.addPoint((Point)idexiTock[0],0);
						st.addPoint((Point)idexiTock[1],0);
						st.addPoint((Point)idexiTock[2],0);
					
					//	p1.X = r1[0].X -(r1[1].X-r1[2].X);
					//	p1.Y = r1[0].Y -(r1[1].Y-r1[2].Y);

						p1.X = ((Point)idexiTock[0]).X -(((Point)idexiTock[1]).X-((Point)idexiTock[2]).X);
						p1.Y = ((Point)idexiTock[0]).Y -(((Point)idexiTock[1]).Y-((Point)idexiTock[2]).Y);
			

						st.addPoint(p1,0);
					
						//st.addPoint(r1[0],0);
						st.addPoint((Point)idexiTock[0],0);
					
												

						return 0;
		
			}
			else
				return -1;

		
		}

		public bool aliSoTockeNaCrti(int indexL,int indexH,Stroke1 st,Graphics g)
		{
		
			int rez = 0;
			Point p1,p2,p3;
			Pen p = new Pen(Color.ForestGreen,3);

			p1 = st.returnElement(indexL);
			p2 = st.returnElement(indexH);
			//prevermio ce je med dvema sosednjima tockama kvadrata ravna crta
			//System.Console.WriteLine(indexL+"..."+indexH);
			for(int j = indexL+1 ;j < indexH-1;j++)
			{
				p3 = st.returnElement(j);
				rez = (int)(Math.Abs((p2.X-p1.X)*(p1.Y-p3.Y)-(p1.X-p3.X)*(p2.Y-p1.Y))/
					Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2)));
				if(rez < this.odstopanjeMedKotoma)
				{
				//	System.Console.WriteLine(j+") "+rez+" : "+p3);
					continue;
				}
				else 
				{
				//	g.DrawEllipse(p,p3.X-10,p3.Y-10,20,20);
				//	System.Console.WriteLine(j+") "+rez+" : "+p3);
					return false;
				}
						
			}
			return true;
		
		}

	}

}
