/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace symmetry
{
	/// <summary>
	/// Summary description for Draw_graph.
	/// </summary>
	public class Draw_graph : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.StatusBar statusBar1;
		private Graphics g;
		private Pen p;
		private System.Windows.Forms.HScrollBar hScrollBar1;
		private System.Windows.Forms.VScrollBar vScrollBar1;
		private System.ComponentModel.IContainer components;
		private int LastScroll_V = 0;
		private int LastScroll_H = 0;
		private Line horizon = new Line();
		private Line vertica = new Line();
		private System.Windows.Forms.Panel panel2;
		private bool cordinatesRead = false;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private Graph graph =  new Graph();
		private Strokes1 allSt = new Strokes1();
		private Stroke1 oneSt = new Stroke1();
	

		public Draw_graph()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Draw_graph));
			this.panel1 = new System.Windows.Forms.Panel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.hScrollBar1 = new System.Windows.Forms.HScrollBar();
			this.vScrollBar1 = new System.Windows.Forms.VScrollBar();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Enabled = ((bool)(configurationAppSettings.GetValue("panel1.Enabled", typeof(bool))));
			this.panel1.Location = new System.Drawing.Point(5, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(5000, 5000);
			this.panel1.TabIndex = 0;
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem4});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3,
																					  this.menuItem2});
			this.menuItem1.Text = "File ";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "-";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "Exit";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem5,
																					  this.menuItem6});
			this.menuItem4.Text = "Tools";
			// 
			// menuItem5
			// 
			this.menuItem5.Checked = true;
			this.menuItem5.Index = 0;
			this.menuItem5.Text = "Histogram";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 1;
			this.menuItem6.Text = "Graph";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 351);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(528, 22);
			this.statusBar1.TabIndex = 1;
			this.statusBar1.Text = "Ready";
			// 
			// hScrollBar1
			// 
			this.hScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.hScrollBar1.LargeChange = 200;
			this.hScrollBar1.Location = new System.Drawing.Point(0, 0);
			this.hScrollBar1.Maximum = 4700;
			this.hScrollBar1.Name = "hScrollBar1";
			this.hScrollBar1.Size = new System.Drawing.Size(512, 16);
			this.hScrollBar1.SmallChange = 100;
			this.hScrollBar1.TabIndex = 2;
			this.hScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hScrollBar1_Scroll);
			// 
			// vScrollBar1
			// 
			this.vScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.vScrollBar1.LargeChange = 200;
			this.vScrollBar1.Location = new System.Drawing.Point(512, 0);
			this.vScrollBar1.Maximum = 4800;
			this.vScrollBar1.Name = "vScrollBar1";
			this.vScrollBar1.Size = new System.Drawing.Size(16, 336);
			this.vScrollBar1.SmallChange = 100;
			this.vScrollBar1.TabIndex = 3;
			this.vScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_Scroll);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel2.Controls.Add(this.hScrollBar1);
			this.panel2.Location = new System.Drawing.Point(0, 336);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(536, 16);
			this.panel2.TabIndex = 4;
			// 
			// Draw_graph
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 373);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.vScrollBar1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Draw_graph";
			this.Text = "Draw_graph";
			this.Resize += new System.EventHandler(this.Draw_graph_Resize);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void menuItem2_Click(object sender, System.EventArgs e) //File->Exit
		{
			Draw_graph.ActiveForm.Close();	
		}

		public void kopirajPodatke(Strokes1 allStrokes) //funkcije kjer vstopamo v to formo
		{
			int i = 0,j = 0;
			Stroke1 st;
	
			for(i = 0;i < allStrokes.numberOfStrokes();i++)
			{
			
								 
				st = allStrokes.returnStrokeObject(i);
				for(j = 0; j<st.numberOfPoints();j++)
				{

				
				oneSt.addPoint(st.returnElement(j),st.returnTimeOfElement(j));
				oneSt.addRecognitionAngle(st.returnRecognitionAngle(j));
           //   oneSt.addRecognitionAcc(st.returnRecognitionAcc(j));
			//	oneSt.addRecognitionSpeed(st.returnRecognitionSpeed(j));
								
				}  //for
				allSt.addStroke(oneSt);
				oneSt = new Stroke1();
			}

		}
		public void inicialise(Strokes1 allStrokes) //funkcije kjer vstopamo v to formo
		{
			int i = 0,j = 0;
			Stroke1 st;
			OneRectangle  r1,r2,r3;
			double recognition = 0.0;
			double ogli ,neogli;
 
			this.kopirajPodatke(allStrokes);
			for(i = 0;i < allStrokes.numberOfStrokes();i++)
			{
				r1 = new OneRectangle();  //vogal
				r2 = new OneRectangle();  //nevogal
				r1.addType(1);
				r2.addType(2);
              	ogli = 1.0 ;
				neogli = 1.0;  
				st = allStrokes.returnStrokeObject(i);
				for(j = 0; j<st.numberOfPoints();j++)
				{

				
					recognition = st.returnRecognitionAngle(j);

					
					if((recognition >= 30 && recognition <= 150) ||
						(recognition >= 210 && recognition <= 330))		//kaj smatramo za dejanski ogel
					{
						r1.increaseNumElements();
						r1.addOgelDegree(recognition);
					}
					else 
					{
						if((recognition > 20 && recognition <  30)||
							(recognition > 150 && recognition <  160)||
							(recognition > 210 && recognition <  220)||
							(recognition > 330 && recognition <  340))     //kaj se smatramo za delni ogel
							ogli = ogli + 1.0;
						else
							neogli = neogli + 1.0;			

                        r2.increaseNumElements();
						r2.addOgelDegree(recognition);

					}
				}  //for

				if((ogli/neogli) > 0.1)
				{

					if(ogli/neogli > 1)
						r2.addRazmerje(1);
					else
						r2.addRazmerje(ogli/neogli);
							r2.addType(3);

				}

			
				if(r1.returnNumOfElem() > 1)
				{
					//graph.addRectangle(r1);
					if(graph.numberOfElements() > 0)
					{
						for(j = 0;j< graph.numberOfElements();j++)
						{
							r3 = (OneRectangle)graph.returnRect(j);
							if(r3.returnPovprecejKotov() > r1.returnPovprecejKotov())
							{
								graph.InsertRectangle(j,r1);
								break;
							}
						}
						if(j == graph.numberOfElements())
								graph.addRectangle(r1);

					}
					else
						graph.addRectangle(r1);


				}

			

				if(r2.returnNumOfElem() > 1)
				{
					if(graph.numberOfElements() > 0)
					{
						for(j = 0;j< graph.numberOfElements();j++)
						{
							r3 = (OneRectangle)graph.returnRect(j);
							if(r3.returnPovprecejKotov() > r2.returnPovprecejKotov())
							{
								graph.InsertRectangle(j,r2);
								break;
							}
						}
						if(j == graph.numberOfElements())
							graph.addRectangle(r2);


					}
					else
						graph.addRectangle(r2);


					//graph.addRectangle(r2);
				}

			}


		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			//this.narisiObjekte();
			//this.narisiObjekte1();
			if(this.menuItem5.Checked)
				this.narisiObjekte1();
			else
				this.narisiGraf();


		}

		private void narisiObjekte()	//narisemo pravoktnike
		{
			
			int i = 0;
			int sirina = 1;
		    int visina = 1;
			double razmerje = 0;		//razmerje med ogli in ne ogli v narisani crti
			OneRectangle oneRec;
			Point p1 = new Point();
			Point p2 = new Point();

		
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
		
			g.Clear(Color.White);
		
		
		
			this.drawLines();
			
			p1.X = horizon.returnFirstPoint().X;
			p1.Y = vertica.returnFirstPoint().Y;
            
			p1.X = p1.X + 10;	//zacetni odmik
            
			
			for(i = 0;i < graph.numberOfElements();i++)
			{
				oneRec = graph.returnRect(i);
				if(oneRec.returnType() == 1)
				{
				visina = 100000;
				sirina = 6;
				 while(visina > (oneRec.returnNumOfElem()*10-10))	
				 {
					 visina = (int)((oneRec.returnNumOfElem()*10)/sirina);
					 sirina ++;
				 }
				
									
					razmerje = 1;
					this.drawRectangle(1,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
					 p1.X = p1.X + sirina;
				}	
			 }
				
			p2.X = p1.X;
			
			for(i = 0;i < graph.numberOfElements();i++)
			{
				oneRec = graph.returnRect(i);
				if(oneRec.returnType() == 3)
				{
					visina = 100000;
					sirina = 6;
					while(visina > (oneRec.returnNumOfElem()*10-10))	
					{
						visina = (int)((oneRec.returnNumOfElem()*10)/sirina);
						sirina ++;
					}
				
					
					razmerje = oneRec.returnRazmerje();
				    this.drawRectangle(3,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
					 p1.X = p1.X + sirina;
				}
					
			}
		
			drawClasificationLine(p2.X);

			for(i = 0;i < graph.numberOfElements();i++)
			{
				oneRec = graph.returnRect(i);
				if(oneRec.returnType() == 2)
				{
					visina = 100000;
					sirina = 6;
					while(visina > (oneRec.returnNumOfElem()*10-10))	
					{
						visina = (int)((oneRec.returnNumOfElem()*10)/sirina);
						sirina ++;
					}
				
						razmerje = 0.0;
			    	 this.drawRectangle(2,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
					p1.X = p1.X + sirina;
				}
					
			}

			
				if(this.vScrollBar1.Location.X-20 < p1.X)
					vertica.addLastPoint(p1.X+20,this.panel2.Location.Y-20);
			
		}



		private void narisiObjekte1()	//narisemo pravokotnike po velikosti
		{
			
			int i = 0;
			int sirina = 1;
			int visina = 1;
			int mnozilnik = 20;
			double razmerje = 0;		//razmerje med ogli in ne ogli v narisani crti
			OneRectangle oneRec;
			Point p1 = new Point();
			Point p2 = new Point();
			Font f = new Font("Arial",8);

		
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
		
			g.Clear(Color.White);
		
		
		
			this.drawLines();
			
			p1.X = horizon.returnFirstPoint().X;
			p1.Y = vertica.returnFirstPoint().Y;
            
			p1.X = p1.X + 10;	//zacetni odmik
            
			
			for(i = 0;i < graph.numberOfElements();i++)		//uredimo pravokotnike po velikosti
			{
				oneRec = graph.returnRect(i);
			
				visina = 100000;
				sirina = 25;
				while(visina > (oneRec.returnPovprecejKotov()*mnozilnik-10))	
				{
					visina = (int)((oneRec.returnPovprecejKotov()*mnozilnik)/sirina);
					sirina ++;
				}
				
				if(oneRec.returnType() == 1)
				{				
					razmerje = 1;
					this.drawRectangle(1,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
					p1.X = p1.X + sirina;
					
				}
				else if(oneRec.returnType() == 2)
				{				
					razmerje = 0.0;
					this.drawRectangle(2,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
					p1.X = p1.X + sirina;
					p2.X = p1.X;
				}
				else if(oneRec.returnType() == 3)
				{				
					razmerje = oneRec.returnRazmerje();
					this.drawRectangle(3,p1.X,p1.Y-visina-1,sirina,visina,razmerje);
				
					p1.X = p1.X + sirina;
				}
			g.DrawString(((int)(oneRec.returnPovprecejKotov())).ToString(),
									f,p.Brush,p1.X-sirina,p1.Y-visina-20);

			}
	
		
		//	drawClasificationLine(p2.X);

					
			if(this.vScrollBar1.Location.X-20 < p1.X)
				vertica.addLastPoint(p1.X+20,this.panel2.Location.Y-30);
			
		}

	

		private void drawLines()  //nariemo koordinatni sistem
		{
			p.Width = 3;
			p.Color = Color.Black;
			
			p.Alignment = PenAlignment.Center;
			p.StartCap = LineCap.ArrowAnchor;

			if(!cordinatesRead)
			{
				horizon.addFirstPoint(this.panel1.Location.X+20,
					this.panel1.Location.Y+10);
				horizon.addLastPoint(this.panel1.Location.X+20,
					this.panel2.Location.Y-10);
				
				vertica.addFirstPoint(this.panel1.Location.X,
					this.panel2.Location.Y-30);
			
				vertica.addLastPoint(this.vScrollBar1.Location.X-20,
					this.panel2.Location.Y-30);
				cordinatesRead = true;
			}
		
			Point po1 = new Point();
			Point po2 = new Point();

			po1 = horizon.returnFirstPoint();
			po2 = horizon.returnLastPoint();

			g.DrawLine(p,po1,po2);
				
			p.StartCap = LineCap.Round;
			p.EndCap = LineCap.ArrowAnchor;

			po1 = vertica.returnFirstPoint();
			po2 = vertica.returnLastPoint();

			g.DrawLine(p,po1,po2);
		
			p.EndCap = LineCap.Round;
		}

		private void drawRectangle(int which,int x,int y,int sirina,int visina,double razmerje)
		{

			Rectangle r;

			p.Width = 3;
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
			if(which == 1)
			{
		
				p.Color = Color.Red;
            
				r = new Rectangle(x,y,sirina,visina);
		
			
				g.FillRectangle(p.Brush,r);	 
				
				p.Color = Color.Black;
				g.DrawRectangle(p,r);
			}
			else if(which == 2)
			{
				r = new Rectangle(x,y,sirina,visina);
				p.Color = Color.Black;
				g.DrawRectangle(p,r);
			}
			else
			{
				p.Color = Color.Red;
         		r = new Rectangle(x,y+ visina -(int)(visina*razmerje),sirina,(int)(visina*razmerje));
				g.FillRectangle(p.Brush,r);	
				r.Y = r.Y - visina +(int)(visina*razmerje);
				r.Height = r.Height + (int)(visina*(1-razmerje));
				p.Color = Color.Black;
				g.DrawRectangle(p,r);

			}

		}

		private void drawClasificationLine(int x)		//tocka na vodoravni premici
		{

			p.Color = Color.Blue;
			p.Width = 2;
            g.DrawLine(p,x,vertica.returnFirstPoint().Y,x,horizon.returnFirstPoint().Y);		

		}
/*--------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------SCROLLBAR--------------------------------------------------------------*/	

		private void vScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{	
			

			Point poi = new Point();
			poi.X = this.panel1.Location.X;
			poi.Y = this.panel1.Location.Y -e.NewValue+ LastScroll_V;
			LastScroll_V = e.NewValue;
			panel1.Location = poi;

		}

		private void hScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
				
			Point poi = new Point(panel1.Location.X - e.NewValue+ LastScroll_H ,panel1.Location.Y );
			poi.X = this.panel1.Location.X - e.NewValue+ LastScroll_H;
			poi.Y = this.panel1.Location.Y;
			LastScroll_H = e.NewValue; 
			panel1.Location = poi;

		}

/*--------------------------------------------------------------------------------------------------------------*/		

		private void Draw_graph_Resize(object sender, System.EventArgs e)
		{
			if(cordinatesRead)
			{
				g.Clear(Color.White);
				horizon.addFirstPoint(this.panel1.Location.X+20,
					this.panel1.Location.Y+10);
				horizon.addLastPoint(this.panel1.Location.X+20,
					this.panel2.Location.Y-10);
				
				
				vertica.addFirstPoint(this.panel1.Location.X,
					this.panel2.Location.Y-30);
			
				vertica.addLastPoint(this.vScrollBar1.Location.X-20,
					this.panel2.Location.Y-30);
			
					cordinatesRead = true;
					if(this.menuItem5.Checked)
						this.narisiObjekte1();
					else
						this.narisiGraf();

			}
		
		}

/*----------------------------------------------------------------------------------------------------------------*/
//____________________________________RISANJE HISTOGRAMA________________________________________________________________
		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			this.narisiObjekte1();
			this.menuItem6.Checked = false;
			this.menuItem5.Checked = true;
		}
/*----------------------------------------------------------------------------------------------------------------*/
//____________________________________RISANJE GRAFA________________________________________________________________													
		private void menuItem6_Click(object sender, System.EventArgs e) //Tools->Graph
		{
			this.narisiGraf();	
			this.menuItem6.Checked = true;
			this.menuItem5.Checked = false;
		}

		

		private void narisiGraf()		//narisemo graf
		{

			ColorChanger ch = new ColorChanger();
			int i = 0,j = 0,zacetni_odmik = 6;
			double mnozilnik = 0.1;
			Stroke1 st;
			Point p1 = new Point();
			Font f = new Font("Arial",7);
		
		
			while(0 <(vertica.returnFirstPoint().Y-mnozilnik*360-zacetni_odmik))	//dejanske vrednosti se mnozijo z stevilom zaradi lepsega izgleda
							mnozilnik = mnozilnik + 0.1;

			mnozilnik = mnozilnik - 0.1;

			if(mnozilnik <= 0)
				mnozilnik = 0.1;

		
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Black);
				p.Width = 2;
				this.Controls.Add(panel1);
			}
			else
			{
				p.Color =  Color.Black;
				p.Width = 2;

			}
			
		

			g.Clear(Color.White);
			
			this.drawLines();
			
			p1.X = horizon.returnFirstPoint().X;
			p1.Y = vertica.returnFirstPoint().Y;
            
		
//risanje crtic in stopnje kota na navpicni premici
			g.DrawString("Kot(v stopinjah)",f,p.Brush,0,0);
			for(i = 1;i<37;i++)
			{
				j = 10*i;
				g.DrawString(j.ToString(),f,p.Brush,(float)(p1.X-20),(float)(p1.Y-10*i*mnozilnik-zacetni_odmik)-6);

				g.DrawLine(p,p1.X-2,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik),
					p1.X+2,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik));

				if(j == 30)			//klasifacijske crte
				{
					p.Color = Color.Yellow;
					p.Width = 2;
					g.DrawLine(p,p1.X+3,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik),
						vertica.returnLastPoint().X,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik));
					p.Color = Color.Black;
					p.Width = 2;
				}
				else if(j == 150)
				{
					p.Color = Color.Yellow;
					p.Width = 2;
					g.DrawLine(p,p1.X+3,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik),
						vertica.returnLastPoint().X,(int)(p1.Y-10*i*mnozilnik-zacetni_odmik));
					p.Color = Color.Black;
					p.Width = 2;
				}

			}
				
			p1.X = p1.X + 5;	

			//risanje tock iz ene poteze
		for(i = 0;i<allSt.numberOfStrokes();i++)
			{
				st = allSt.returnStrokeObject(i);
				for(j = 0;j<st.numberOfPoints();j++)
				{
					//p.Color = ch.colorize(angleToColor(st.returnRecognitionAngle(j)));
					p.Color = returnClassColor(st.returnRecognitionAngle(j));
					p.Width = 2;
					g.DrawEllipse(p,p1.X,p1.Y-(int)(st.returnRecognitionAngle(j)*mnozilnik)-zacetni_odmik,2,2);
					
					p.Color = Color.Black;
					p.Width = 1;
					g.DrawLine(p,p1.X,p1.Y,p1.X,p1.Y+4);	//crtice na spodnji premice
					
					p1.X = p1.X + 3;	

				}

			}
			p.Width = 2; 
			g.DrawString("Zaporedne stevilke tock",f,p.Brush,p1.X+20,p1.Y);
		

		
	
			if(this.vScrollBar1.Location.X-20 < p1.X)						//ce je potrbno povecamo spodnjo crto  v grafu
				vertica.addLastPoint(p1.X+20,this.panel2.Location.Y-30);
			
		
		}


		private double angleToColor(double angle)		//pretvorba kota 0 - 360 stopinj v double iz intervala -1 do 1
		{

			return ((angle/360)*2-1);
		}

		private Color returnClassColor(double angle)
		{
			
			if(angle > 30 && angle <150)
					return Color.Red;
			else if(angle <= 30)
					return Color.Blue;
			else
				return Color.Green;
			
		}

				

/*-----------------------------------------------------------------------------------------------------------------*/
	
	}
}
