/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Collections;

namespace symmetry
{
	/// <summary>
	/// Summary description for Garph.
	/// </summary>
	public class Graph
	{
		ArrayList list = new ArrayList();
	

		public Graph()
		{
			
		}

		public void addRectangle(OneRectangle oneRec)
		{
			list.Add(oneRec);

		}

		public void InsertRectangle(int index,OneRectangle oneRec)
		{
			list.Insert(index,oneRec);

		}

		public OneRectangle returnRect(int i)
		{
			return (OneRectangle)list[i];
		}

		public int numberOfElements()
		{
			return list.Count;
		}
		
		public void clearGraph()
		{
			list.Clear();
		}
	

		~ Graph()
		{
			
		}


	}

	public class OneRectangle
	{
		private int type = 0;
		private int numberOfElements = 0;
		private double razmerje = 0.0;
		private double sestevekKotov = 0.0;
		private double d1;  //povprecje kotov
		bool isCorner=false;


		public OneRectangle()
		{
			
		}

		public void addType(int i)
		{
			type = i;
		}

		public void increaseNumElements()
		{
			numberOfElements++;

		}

		public void addOgelDegree(double degrees)
		{
			sestevekKotov = sestevekKotov + degrees;	
		}

		public void addRazmerje(double x)
		{
			razmerje = x;
		}

		
		public int returnType()
		{
			return type;
		}

		public int returnNumOfElem()
		{
			return numberOfElements;
		}

		public double returnRazmerje()
		{
			return razmerje;
		}

		public double returnPovprecejKotov()
		{
			return sestevekKotov/numberOfElements;
		}

		public void addDegree(double d11)
		{
			d1=d11;
		}

		public double getDegree()
		{
			return d1;
		}
		
		public void setCorner() 
		{
			isCorner=true;
		}

		public bool getCorner()
		{
			return isCorner;
		}



		~ OneRectangle()
		{
			
		}


	}
}
