/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/



using System;
using System.Collections;
using System.Drawing;

namespace symmetry
{
	/// <summary>
	/// Summary description for PointManipulation.
	/// </summary>
	public class PointManipulation
	{
		public PointManipulation()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void alignToGrid(Stroke1 str,int size)//size je razdalja med posameznimi crtami	v mrei
		{

			int i = 0;
			int j = 0;
			Point po;

			for(i = 0;i<str.numberOfPoints();i++)
			{
				po = str.returnElement(i);

				j = (int)(po.X)%size;

				if((j!=0)&& (j < (int)(size/2)))
				{
					while((int)(po.X)%size!= 0)
						po.X = po.X - 1;
				}
				else if((j!=0))
				{
					while((int)(po.X)%size!= 0)
						po.X = po.X + 1;
				}

				j = (int)(po.Y)%size;
				
				if((j!=0)&& (j < (int)(size/2)))
				{
					while((int)(po.Y)%size!= 0)
						po.Y = po.Y - 1;
				}
				else if((j!=0))
				{
					while((int)(po.Y)%size!= 0)
						po.Y = po.Y + 1;
				}

				str.changePoint(po,i);
			}

		}

		public void roundDistance(Stroke1 str,int dolz) //zaokrozimo razdaljo med tockami na veckratnik dolz
		{

			int i = 0;
			int dis = 0,dis1 = 0;
			int angle = 0;
			Point p1,p2,p3;
			p3 = new Point();
			Recognizer2 recog = new Recognizer2();

			if(str.numberOfPoints() > 2)
			for(i = 0;i<str.numberOfPoints()-1;i++)
			{
				p1 = str.returnElement(i);
				p2 = str.returnElement(i+1);

			
				dis = (int)recog.pointDistance(p1,p2);

				while((dis%dolz)!=0)
				{
					
					p3.X  = p2.X + 1;
					p3.Y  = p2.Y + 1;
					dis1 = (int)recog.pointDistance(p1,p2);
					angle = (int)recog.calcAngle(p1,p2,p3);
					if(dis1 < dis || angle != 180)
					{
						p3.X  = p2.X - 1;
						p3.Y  = p2.Y + 1;
						dis1 = (int)recog.pointDistance(p1,p2);
						angle = (int)recog.calcAngle(p1,p2,p3);
					
						if(dis1 < dis || angle != 180)
						{
							p3.X  = p2.X + 1;
							p3.Y  = p2.Y - 1;
							dis1 = (int)recog.pointDistance(p1,p2);
							angle = (int)recog.calcAngle(p1,p2,p3);

							if(dis1 < dis || angle != 180)
							{
								p3.X  = p2.X - 2;
								dis1 = (int)recog.pointDistance(p1,p2);
								angle = (int)recog.calcAngle(p1,p2,p3);

								if(dis1 < dis || angle != 180)
								{
									p3.Y  = p2.Y - 1;
									dis1 = (int)recog.pointDistance(p1,p2);
									angle = (int)recog.calcAngle(p1,p2,p3);
								
									if(dis1 < dis || angle != 180)
									{
										p3.X  = p2.X + 1;
										dis1 = (int)recog.pointDistance(p1,p2);
										angle = (int)recog.calcAngle(p1,p2,p3);

									}

								}

							}

						}

					}
					
					dis = dis1;
					p2.X  = p3.X;
					p2.Y  = p3.Y;
							
				}
				str.changePoint(p2,i+1);
			}

		}

		public void roundAngle(Stroke1 str,int vKot) //zaokrozimo kot med tockami na veckratnik vKot
		{

			int i = 0;
			int angle = 0;
			double angleR = 0.0;
			int dist = 0;
			Point p1,p2,p3;
			Recognizer2 recog = new Recognizer2();

			if(str.numberOfPoints() >= 3)
			for(i = 0;i<str.numberOfPoints()-2;i++)
			{
				p1 = str.returnElement(i);
				p2 = str.returnElement(i+1);
				p3 = str.returnElement(i+2);

				angle = (int)recog.calcAngle(p1,p2,p3);
				dist = (int)recog.pointDistance(p2,p3);
				
					
				
				if((angle%vKot)!=0)
				{
					int dejanskiKot = 0;
					dejanskiKot = angle%vKot;

				//	if(dejanskiKot < (int)(vKot/2))
				//		angleR = ((360-dejanskiKot)/180)*Math.PI;	
				//	else
						angleR = ((dejanskiKot)/180)*Math.PI; //pretvorimo kot v radiane
					
					angleR =Math.PI/10;

			
			//		p2.X  = (int)(dist*Math.Cos(angleR))+p3.X;		//premik tocke iscemo na  kroznici
			//		p2.Y  = (int)(dist*Math.Sin(angleR))+p3.Y;
					
					p2.X = (int)(Math.Cos(angleR)*(p2.X) - Math.Sin(angleR)*(p2.Y));
					p2.Y = (int)(Math.Sin(angleR)*(p2.X) + Math.Cos(angleR)*(p2.Y));//+p3.Y;
				
					str.changePoint(p2,i+1);
				}

			}

		}

		public void popraviSkorajOgle(Stroke1 str,Graphics g,Pen p) //popravimo posamezne tocke,da dobimo lepse like
		{

			int i = 0,j = 0;
			int angle1 = 0;
			int distance = 0;
			int indexL = 0,indexH = 0;
			int obcutlivost = 20;
			ArrayList indexiZaOdstranit = new ArrayList();
			Point p1,p2,p3;
			Recognizer2 recog = new Recognizer2();


			if(str.numberOfPoints() > 4)
			{
				for(i = 0;i<str.numberOfPoints()-2;i++)
				{
					p1 = str.returnElement(i);
					p2 = str.returnElement(i+1);
					p3 = str.returnElement(i+2);


				

					angle1 = (int)recog.calcAngle(p1,p2,p3);
					distance =(int)recog.pointDistance(p1,p2);	
					
					if(angle1 <= 110)
					{
						indexH = i+1;
						if(aliSoTockeNaCrti(indexL,indexH,str,obcutlivost))
						{
							
							for(j = indexL+1;j< indexH;j++)
							{
								if(!indexiZaOdstranit.Contains(j))
								indexiZaOdstranit.Add(j);
								
							}				

						}
						else if(Math.Abs(angle1-180) < 30)
						{
					
							p2.X  = (int)((p1.X+p3.X)/2); 
							p2.Y  = (int)((p1.Y + p3.Y)/2);
							str.changePoint(p2,i+1);
					
						}
	            
						indexL = indexH;
				
					}
		
				}

		
				for(int k = indexiZaOdstranit.Count-1;k >=0;k--)
					str.removePoint((int)indexiZaOdstranit[k]);
				

				indexiZaOdstranit.Clear();

				for(i = 0;i<str.numberOfPoints()-2;i++)
				{
					p1 = str.returnElement(i);
					p2 = str.returnElement(i+1);
					p3 = str.returnElement(i+2);

	
					distance =(int)recog.pointDistance(p2,p3);	
					angle1 = (int)recog.calcAngle(p1,p2,p3);
					
					if(distance <= 9)
					{
						str.removePoint(i+1);
						i--;
					
					}
				

			
				}

				for(i = 0;i<str.numberOfPoints()-2;i++)
				{
					p1 = str.returnElement(i);
					p2 = str.returnElement(i+1);

					if(Math.Abs(p1.X - p2.X)< 20)
					{
						p2.X = p1.X;
						str.changePoint(p2,i+1);
					}

					if(Math.Abs(p1.Y - p2.Y)< 20)
					{
						p2.Y = p1.Y;
						str.changePoint(p2,i+1);
					}
				}
					

			}
				indexiZaOdstranit.Clear();

		}
	
		public bool aliSoTockeNaCrti(int indexL,int indexH,Stroke1 st,int obcutlivost)
		{
		
			int rez = 0;
			Point p1,p2,p3;
	

			p1 = st.returnElement(indexL);
			p2 = st.returnElement(indexH);
			for(int j = indexL+1 ;j < indexH;j++)
			{
				p3 = st.returnElement(j);
				rez = (int)(Math.Abs((p2.X-p1.X)*(p1.Y-p3.Y)-(p1.X-p3.X)*(p2.Y-p1.Y))/
					Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2)));
				if(rez < obcutlivost)
				{					
					continue;
				}
				else 
				{
					
					return false;
				}
						
			}
			return true;
		
		}

		public void drawGrid(Pen p,Graphics g,int x,int y,int size) //width je sirina crt grida
		{															//size je razdalja med posameznimi crtami	
																		//x in y so visina in sirina okna

		
			int i = 0;
			Point p1 = new Point(0,0);
			Point p2 = new Point(0,0);




			for(i = 0;i<x;i =i+ size)
			{
				p1.X = i;
				p1.Y = 0;
				p2.X = i;
				p2.Y = y;
				g.DrawLine(p,p1,p2);
			}

			for(i = 0;i<y;i = i + size)
			{
				p1.X = 0;
				p1.Y = i;
				p2.X = x;
				p2.Y = i;
				g.DrawLine(p,p1,p2);

			}
		
		

		}


		}
}
