/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace symmetry
{
	/// <summary>
	/// Summary description for Set_corner.
	/// </summary>
	
	public class Set_corner : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private bool mouseDown = false, presentR=false;
		private int objectDrawn, counter2 = 0, brn;
		private double ugodnoS;
		private Point lastPoint = Point.Empty, ptR;
		private Graphics g;
		private Pen p;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private Stroke1 oneSt =  new Stroke1();
		private Strokes1 allSt = new Strokes1();
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.Label label1;
		private ArrayList diffCorner1 = new ArrayList(); //tabela spodnjih kvadratov
		private ArrayList diffCorner2 = new ArrayList();//tabela zgornjih  kvadratov 
		//private ArrayList diffLines = new ArrayList();	//naklon crte
		private int indexOfCorner = 0;
		private Point p1 = new Point();
		private Point p2 = new Point();
		private ArrayList l1 = new ArrayList();//tabeli v kateri shranimo  premice, ki oznaujejo kote
		private ArrayList rectangle1 = new ArrayList();	
		private ArrayList rectangle2 = new ArrayList();	
		private Recognizer r = new Recognizer();
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;
		private HiPerfTimer clock1 = new HiPerfTimer();
        private HiPerfTimer clock2 = new HiPerfTimer();
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.RadioButton radioButton3;
		private System.Windows.Forms.MenuItem menuItem13;  //urca
		private double timer=0;
		private Test_data td;
		public SetAttributes sa = new SetAttributes();
		


		public Set_corner()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Set_corner));
			this.panel1 = new System.Windows.Forms.Panel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton3 = new System.Windows.Forms.RadioButton();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Location = new System.Drawing.Point(16, 64);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(560, 352);
			this.panel1.TabIndex = 0;
			this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			this.panel1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseMove);
			this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem3,
																					  this.menuItem10});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8,
																					  this.menuItem7,
																					  this.menuItem2,
																					  this.menuItem9,
																					  this.menuItem4});
			this.menuItem1.Text = "File";
			this.menuItem1.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 0;
			this.menuItem8.Text = "New";
			this.menuItem8.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Enabled = false;
			this.menuItem7.Index = 1;
			this.menuItem7.Text = "Next";
			this.menuItem7.Click += new System.EventHandler(this.menuItem7_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "Save As";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 3;
			this.menuItem9.Text = "-";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 4;
			this.menuItem4.Text = "Exit";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click_1);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem6,
																					  this.menuItem5});
			this.menuItem3.Text = "Edit";
			this.menuItem3.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem6
			// 
			this.menuItem6.Enabled = false;
			this.menuItem6.Index = 0;
			this.menuItem6.Text = "Clear Corner";
			this.menuItem6.Visible = false;
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "Undo";
			this.menuItem5.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 2;
			this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem11,
																					   this.menuItem12,
																					   this.menuItem13});
			this.menuItem10.Text = "Tools";
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 0;
			this.menuItem11.Text = "Draw Graph";
			this.menuItem11.Click += new System.EventHandler(this.menuItem11_Click);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 1;
			this.menuItem12.Text = "Draw graph 2";
			this.menuItem12.Click += new System.EventHandler(this.menuItem12_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.Text = "Test input data";
			this.menuItem13.Click += new System.EventHandler(this.test_input_data_button_click);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.AddExtension = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.AddExtension", typeof(bool))));
			this.saveFileDialog1.CheckFileExists = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CheckFileExists", typeof(bool))));
			this.saveFileDialog1.CheckPathExists = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CheckPathExists", typeof(bool))));
			this.saveFileDialog1.CreatePrompt = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CreatePrompt", typeof(bool))));
			this.saveFileDialog1.DefaultExt = ((string)(configurationAppSettings.GetValue("saveFileDialog1.DefaultExt", typeof(string))));
			this.saveFileDialog1.DereferenceLinks = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.DereferenceLinks", typeof(bool))));
			this.saveFileDialog1.FileName = ((string)(configurationAppSettings.GetValue("saveFileDialog1.FileName", typeof(string))));
			this.saveFileDialog1.Filter = ((string)(configurationAppSettings.GetValue("saveFileDialog1.Filter", typeof(string))));
			this.saveFileDialog1.FilterIndex = ((int)(configurationAppSettings.GetValue("saveFileDialog1.FilterIndex", typeof(int))));
			this.saveFileDialog1.InitialDirectory = ((string)(configurationAppSettings.GetValue("saveFileDialog1.InitialDirectory", typeof(string))));
			this.saveFileDialog1.OverwritePrompt = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.OverwritePrompt", typeof(bool))));
			this.saveFileDialog1.RestoreDirectory = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.RestoreDirectory", typeof(bool))));
			this.saveFileDialog1.ShowHelp = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.ShowHelp", typeof(bool))));
			this.saveFileDialog1.Title = ((string)(configurationAppSettings.GetValue("saveFileDialog1.Title", typeof(string))));
			this.saveFileDialog1.ValidateNames = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.ValidateNames", typeof(bool))));
			this.saveFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.saveFileDialog1_FileOk);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(552, 48);
			this.label1.TabIndex = 0;
			this.label1.Text = "Please draw a corner between two rectangles and a line";
			// 
			// timer1
			// 
			this.timer1.Interval = 2000;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// radioButton1
			// 
			this.radioButton1.Location = new System.Drawing.Point(72, 432);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(80, 24);
			this.radioButton1.TabIndex = 1;
			this.radioButton1.Text = "Coloring";
			// 
			// radioButton2
			// 
			this.radioButton2.Location = new System.Drawing.Point(162, 432);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(80, 24);
			this.radioButton2.TabIndex = 2;
			this.radioButton2.Text = "Coloring 2";
			// 
			// radioButton3
			// 
			this.radioButton3.Checked = true;
			this.radioButton3.Location = new System.Drawing.Point(252, 432);
			this.radioButton3.Name = "radioButton3";
			this.radioButton3.Size = new System.Drawing.Size(90, 24);
			this.radioButton3.TabIndex = 3;
			this.radioButton3.TabStop = true;
			this.radioButton3.Text = "Show corner";
			// 
			// Set_corner
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 461);
			this.Controls.Add(this.radioButton3);
			this.Controls.Add(this.radioButton2);
			this.Controls.Add(this.radioButton1);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.label1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Set_corner";
			this.ResumeLayout(false);

		}
		#endregion

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			
			if(objectDrawn == 0)
				this.narisiObjekte1();
			else
				this.narisiObjekte2();
			
		}

		private void narisiObjekte1()
		{
			Line line = new Line();
			int i;
			
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.FromName("Black"));
				p.Width = 2;
				p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
				p.LineJoin = LineJoin.Round;
				this.Controls.Add(panel1);
				this.getPositionsOfCorners();
			}

			g.Clear(Color.White);
			
			p.Color = Color.FromName("Red");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);
		
			line.addFirstPoint(p1.X,p1.Y);
			line.addLastPoint(p2.X,p2.Y);
          
			if(p1.X < p2.X)
			{
	
				line.addFirstPoint(p1.X+50,p2.Y-50);
				line.addLastPoint(p1.X-50,p2.Y+50);
				
			}
			else
			{
				line.addFirstPoint(p1.X-50,p2.Y-50);
				line.addLastPoint(p1.X+50,p2.Y+50);
	
			}

			g.DrawLine(p,line.returnFirstPoint(),line.returnLastPoint());
			p.Color = Color.FromName("Black");

			for( i = 0;i<oneSt.numberOfPoints()-1;i++)
				g.DrawLine(p,oneSt.returnElement(i),oneSt.returnElement(i+1));

			sa.angle=-3; //atributi
			sa.speed=-3;
			sa.linearR=-3;

		}


		private void narisiObjekte2()
		{
			Line line = new Line();
			int i;
			
			g.Clear(Color.White);
			
			p.Color = Color.FromName("Black");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);
		
			line.addFirstPoint(p1.X,p1.Y);
			line.addLastPoint(p2.X,p2.Y);
          
			if(p1.X < p2.X)
			{
	
				line.addFirstPoint(p1.X+50,p2.Y-50);
				line.addLastPoint(p1.X-50,p2.Y+50);
				
			}
			else
			{
				line.addFirstPoint(p1.X-50,p2.Y-50);
				line.addLastPoint(p1.X+50,p2.Y+50);
	
			}

			g.DrawLine(p,line.returnFirstPoint(),line.returnLastPoint());
		

			for( i = 0;i<oneSt.numberOfPoints()-1;i++)
				g.DrawLine(p,oneSt.returnElement(i),oneSt.returnElement(i+1));
		
			
			//p1 = r.addRecog(oneSt);
			//p.Color = Color.Cyan;
			//g.DrawRectangle(p,p1.X-10,p1.Y-10,20,20);
		
		}

		private void getPositionsOfCorners()//shranimo vse mozne pozicije kvadratov in naklonov crt
		{
			
			p1.X =100;
			p1.Y = 300;
			diffCorner1.Add(p1); 
			p1.X =200;
			p1.Y = 200;
			diffCorner1.Add(p1);
			p1.X = 300;
			p1.Y = 200;
			diffCorner1.Add(p1);
			p1.X =400;
			p1.Y =100;
			diffCorner2.Add(p1); 
			p1.X =300;
			p1.Y = 100;
			diffCorner2.Add(p1);
			p1.X = 100;
			p1.Y = 100;
			diffCorner2.Add(p1);

		}

        

		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			p1 = (Point)diffCorner1[indexOfCorner];
			p2 = (Point)diffCorner2[indexOfCorner];

			if(((e.X >= p1.X && e.X <= p1.X+ 30)&& (e.Y >= p1.Y && e.Y <= p1.Y+ 30))||	//samo ce zadanemo v kvadratek lahko zacnemo risat
				((e.X >= p2.X && e.X <= p2.X+ 30)&& (e.Y >= p2.Y && e.Y <= p2.Y+ 30)))
				mouseDown = true;

			if(objectDrawn == 1)
			{
				
				p1 = (Point)diffCorner1[indexOfCorner];
				p2 = (Point)diffCorner2[indexOfCorner];
				
				rectangle1.Add(p1);		//shranimo tocke kjer je narisan kvadrat1
				rectangle2.Add(p2);		//shranimo tocke kjer je narisan kvadrat2
		
				objectDrawn++;
				
				
			}
			timer=0;  //tukej zanemo merit cajt
			clock1.Start();
		}

		private void panel1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if((lastPoint.Equals(Point.Empty))) 
				lastPoint = new Point(e.X,e.Y);
				
			if(mouseDown && (e.Button == MouseButtons.Left)&& (objectDrawn == 0))
			{
				Point pMousePos = new Point(e.X,e.Y);
                clock1.Stop(); //as vsake toke vnesemo v tabelo
			
				timer=timer+clock1.Duration;
				oneSt.addPoint(pMousePos,timer);  //dodamo tocko in cajt
				counter2++;

				r.getAngleS(oneSt,2);  //sprotno raunanje kota tock
				r.addRecog2000S(oneSt,15); //sprotno raunanje regresije
				r.getSpeedS(oneSt,3); //sprotno racunanje hitrosti
                calcR(oneSt); //izracunamo verjetnost tock
				
				chooseC(pMousePos,lastPoint);
                
         
				clock1.Start();
													
			} //if
			
			lastPoint = new Point(e.X,e.Y);

		}  

		private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
            Color barva;
			double count1;

			if((objectDrawn == 0) && (mouseDown == true))
			{
				if (oneSt.numberOfPoints()>0) //vnose shranjujemo samo, ce se miska premakne 
				{
					Point pt1,pt2;
					objectDrawn ++;
					oneSt.addWidth(2);
					oneSt.addColor(p.Color);
					allSt.addStroke(oneSt);
			
					pt1=this.whereIsCorner();  //!!!!!!!!!!!!!!!!!!!!!!!!
					oneSt.setPoint(pt1); //tocka, ki je najbolj oddaljenja od diagonale
				    
				
					//pt1 = r.addRecog(oneSt);  //lin. regresija
	/*		        
					for (int i=0; i<oneSt.numberOfPoints();i++)
					{ 
						System.Console.WriteLine("{0}",oneSt.returnRecognitionAll(i));

					}			
                    System.Console.WriteLine("");
*/
					oneSt.clearPointRecognitionAll();
					oneSt.clearPointRecognition();
					oneSt.clearPointRecognitionAngle();
					oneSt.clearPointRecognitionSpeed();
                    
					r.getSpeed(oneSt,3); //hitrost
					r.getAngle(oneSt,2); //racunanje kota
					r.addRecog2000(oneSt,15);  //lin. regresija
						
			
					double iRmax= 0,iSmax= 0;
					//p.Color = Color.DeepSkyBlue;
					for(int i = 0;i<oneSt.numberOfPoints();i++) //poberem max vrednosti
					{
						if (oneSt.returnRecognitionSpeed(i)>iSmax) iSmax=oneSt.returnRecognitionSpeed(i);
						if (oneSt.returnRecognition(i)>iRmax) iRmax=oneSt.returnRecognition(i);
						//System.Console.WriteLine("Regresija: {0}", oneSt.returnRecognition(i));
						/*if(oneSt.returnRecognitionAngle(i) > 70 && 	oneSt.returnRecognitionAngle(i)< 110 )
						{
							pt1 = oneSt.returnElement(i);
							g.DrawRectangle(p,pt1.X-10,pt1.Y-10,20,20);
						}
						*/
					}
                
					double zR,zS,zA,iAmax=0;
					int maxI=-1;
					for(int i = 0;i<oneSt.numberOfPoints();i++) //izpolnim seznam 'pointRecognitionAll'
					{
						if (oneSt.returnRecognition(i)!=-2) zR=oneSt.returnRecognition(i)/iRmax;
						else zR=0;
                    
						if (oneSt.returnRecognitionAngle(i)!=-1) //predpostavim da je kot 90 stopinj idealen kot!!!!!
						{
							if (oneSt.returnRecognitionAngle(i)<=90) zA=oneSt.returnRecognitionAngle(i)/90;
							else zA=1-(oneSt.returnRecognitionAngle(i)-90)/90;
							/*zA=1-oneSt.returnRecognitionAngle(i)/180; 
							System.Console.WriteLine("Za pri kotu {0} znaa tono: {1}",oneSt.returnRecognitionAngle(i),zA);*/
							
						}
						else zA=0;
                    
						if (oneSt.returnRecognitionSpeed(i)!=-1) zS=1-(oneSt.returnRecognitionSpeed(i)/iSmax);
						else zS=0;

						//System.Console.WriteLine("hitrost(0-1): {0}",zS);   

						oneSt.addRecognitionAll((zR+zS+zA)/3);
						if (((zR+zS+zA)/3)>iAmax) 
						{
							iAmax=((zR+zS+zA)/3);
							maxI=i;
						}


						//oneSt.addRecognitionAll(zS);
					} //for
					sa.angle=oneSt.returnRecognitionAngle(maxI); //atributi
					sa.speed=oneSt.returnRecognitionSpeed(maxI);
					sa.linearR=oneSt.returnRecognition(maxI);

/*
					System.Console.WriteLine("");
					for (int i=0; i<oneSt.numberOfPoints();i++)
					{ 
						System.Console.WriteLine("{0}",oneSt.returnRecognitionAll(i));

					}
*/
					pt1=oneSt.returnElement(0);
					p.Width=8;
					if (radioButton1.Checked) 
					{
						for(int i = 1;i < oneSt.numberOfPoints();i++) //izracunamo odtenek in pobarvamo stroke
						{
					
							if (oneSt.returnRecognitionAll(i)>=0 && oneSt.returnRecognitionAll(i) <=1)
							{
								barva=returnColor(oneSt.returnRecognitionAll(i));
								p.Color=barva;
							}
							else 
							{ 
								p.Color=Color.White;
								System.Console.WriteLine("Vrednost tocke {0} ni na intervalu (0,1)!!!",oneSt.returnRecognitionAll(i));
							}
					
							pt2=oneSt.returnElement(i);
							g.DrawLine(p,pt1,pt2); //stroke barvani na koncu
							pt1=oneSt.returnElement(i);
						}  //for 
					} //if

					this.timer1.Start();
					/*count1=0;
					clock2.Start();
					while (count1 < 1) //zakasnitev
					{
						clock2.Stop();
						count1=count1+clock2.Duration;
						clock2.Start();
					}
					clock2.Stop();*/
				}//ifN
			}  //if
			mouseDown = false;
			counter2=0;  //stevec pobranih tock se resetira
			presentR=false; //prav tako ta spremenljivka
			brn=-1;    //tudi ta
			p.Width=2;
			p.Color=Color.Black;
		}
		
		private Color returnColor(double dC)  //vrnemo barvo glede na argument (med 0 in 1)
		{
			Color c1;
			
            double bluefunc,bluefunc2,redfunc,redfunc2,cgre;
			 
			bluefunc = 1.0 / (1.0 + Math.Exp(-10*(dC-0.6)));
			redfunc =  1.0 / (1.0 + Math.Exp(10*(dC-0.5)));
			   
			redfunc2 = 1.0 / (1.0 + Math.Exp(10*(dC-0.4)));
			bluefunc2 = 1.0 / (1.0 + Math.Exp(-10*(dC-0.75)));

			cgre =  1 - Math.Pow(redfunc2,2) - bluefunc2;
			   
			//dobljene vrednosti so na intervalu (0,1), tako da jih je potrebno se pomnoziti
			redfunc=redfunc*256; //inteval od 0 do 256 !!!
			cgre=cgre*256;
			bluefunc=bluefunc*256;

			c1=Color.FromArgb((int)redfunc,(int)cgre, (int)bluefunc);
			
			return c1;
		}
		
		private void saveFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)//File -Save As..
		{
			int i = 0;
			int j = 0;
			Point po;
			//Point whereIsCorner = new Point();
			Stroke1 st = null;
			StreamWriter writer;
			//Line premica;
	
			writer = new StreamWriter(saveFileDialog1.FileName,true);
		
			if((allSt.numberOfStrokes())> 0)
			{
				
				for(j = 0;j < allSt.numberOfStrokes();j++)
				{	
					st = (Stroke1)allSt.returnStrokeObject(j);
					//premica = (Line)l1[j];
					for(i = 0;i < st.numberOfPoints();i++)
					{
						po = st.returnElement(i);
						/*
						if(distance > premica.distancToPoint(po))
						{
							whereIsCorner.X = po.X;
							whereIsCorner.Y = po.Y;
							distance = premica.distancToPoint(po);
						}
                        */
						writer.Write(po.X.ToString()+"; "+po.Y.ToString()+"; ");
						writer.Write("{0:#.00}; {1:#.00}; {2:#.00}; ",st.returnRecognitionAngle(i),st.returnRecognition(i),st.returnRecognitionSpeed(i));
				        writer.Write("{0:#.00}; {1:#.00}",st.returnTimeOfElement(i),st.returnRecognitionAll(i));
						writer.WriteLine("");
				
					} //for i
                    
					//distance = 1000;
                    writer.WriteLine("$"); //znak, ki pove da je konec enega vnosa
				//	p.Color = Color.Red;
				//	g.DrawEllipse(p,whereIsCorner.X-15,whereIsCorner.Y-15,30,30);
				//	p.Color = Color.Black;

					//writer.Write("|");
					//writer.Write(st.returnColor().Name+",");
					//writer.Write(st.returnWidth().ToString()+","); 
					/*
					//po = premica.returnFirstPoint();
					writer.Write(po.X.ToString()+","+po.Y.ToString()+",");	//tocki na premici
					//po = premica.returnLastPoint();
					writer.Write(po.X.ToString()+","+po.Y.ToString()+",");
					po = (Point)rectangle1[j];
					writer.Write(po.X.ToString()+","+po.Y.ToString()+","); //poziciji kvadratov
					po = (Point)rectangle2[j];
					writer.Write(po.X.ToString()+","+po.Y.ToString()+",");
					writer.Write(whereIsCorner.X.ToString()+","+whereIsCorner.Y.ToString()+";");//kje je kot
					writer.Write(writer.NewLine);
					*/
				} //for i
			}  //for j
			
				
						
			//l1.Clear();
			//rectangle1.Clear();
			//rectangle2.Clear();
			writer.Close();	
			saveFileDialog1.Dispose();
		}

		private void menuItem2_Click(object sender, System.EventArgs e) //File -> Save As
		{
			saveFileDialog1.ShowDialog();
		}

		private void menuItem4_Click(object sender, System.EventArgs e) //Edit ->Undo
		{
			Line line = new Line();	

			g.Clear(Color.White);

			p.Color = Color.FromName("Red");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);

			line.addFirstPoint(p1.X,p1.Y);
			line.addLastPoint(p2.X,p2.Y);
            
			if(p1.X < p2.X)
			{
	
				line.addFirstPoint(p1.X+50,p2.Y-50);
				line.addLastPoint(p1.X-50,p2.Y+50);
				
			}
			else
			{
				line.addFirstPoint(p1.X-50,p2.Y-50);
				line.addLastPoint(p1.X+50,p2.Y+50);
	
			}
			g.DrawLine(p,line.returnFirstPoint(),line.returnLastPoint());
			p.Color = Color.FromName("Black");
		   
			allSt.clearLastStroke();
			objectDrawn = 0;
		}

		

		private void menuItem1_Popup(object sender, System.EventArgs e)//poprava mainMenu
		{
			lastPoint = Point.Empty;
		}

		private void menuItem6_Click(object sender, System.EventArgs e) //Edit -> Clear corner
		{
		

			objectDrawn = 1;
			g.Clear(Color.White);
			
			p.Color = Color.FromName("Red");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);
			g.DrawLine(p,p1.X-50+15,p2.Y+50+15,p1.X+50+15,p2.Y-50+15);
			p.Color = Color.FromName("Black");
			for(int i =0;i<oneSt.numberOfPoints()-1;i++) 
				g.DrawLine(p,oneSt.returnElement(i),oneSt.returnElement(i+1));
		}

		private void menuItem8_Click(object sender, System.EventArgs e)//File -> New
		{
			Line line = new Line();	

			g.Clear(Color.White);
			p.Color = Color.FromName("Red");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);
		
			line.addFirstPoint(p1.X,p1.Y);
			line.addLastPoint(p2.X,p2.Y);
            
			if(p1.X < p2.X)
			{
	
				line.addFirstPoint(p1.X+50,p2.Y-50);
				line.addLastPoint(p1.X-50,p2.Y+50);
				
			}
			else
			{
				line.addFirstPoint(p1.X-50,p2.Y-50);
				line.addLastPoint(p1.X+50,p2.Y+50);
	
			}
			g.DrawLine(p,line.returnFirstPoint(),line.returnLastPoint());
			p.Color = Color.FromName("Black");
    		
			p.Width = 2;
			allSt.clearStrokes();
			allSt = new Strokes1();
			oneSt = new Stroke1();
			objectDrawn = 0;

			

		
		}

		private void menuItem7_Click(object sender, System.EventArgs e)//File -> Next
		{
			
			this.changeDisplay();
		}
	
		public void changeDisplay()
		{
			Line line = new Line();	
	
			g.Clear(Color.White);
			
			if(indexOfCorner < 2)
			indexOfCorner++;
			else
			indexOfCorner = 0;

			p.Color = Color.FromName("Red");
			p1 = (Point)diffCorner1[indexOfCorner];
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			p2 = (Point)diffCorner2[indexOfCorner];
			g.DrawRectangle(p,p2.X,p2.Y,30,30);
		
			line.addFirstPoint(p1.X,p1.Y);
			line.addLastPoint(p2.X,p2.Y);
            
			if(p1.X < p2.X)
			{
	
				line.addFirstPoint(p1.X+50,p2.Y-50);
				line.addLastPoint(p1.X-50,p2.Y+50);
			}
			else
			{
			line.addFirstPoint(p1.X-50,p2.Y-50);
			line.addLastPoint(p1.X+50,p2.Y+50);
			}
			g.DrawLine(p,line.returnFirstPoint(),line.returnLastPoint());
			p.Color = Color.FromName("Black");
			p.Width = 2;
			oneSt = new Stroke1();
			objectDrawn = 0;
		}


		private void menuItem4_Click_1(object sender, System.EventArgs e)//File -> Exit
		{
			Set_corner.ActiveForm.Close();
		}

		private Point whereIsCorner()
		{
			int i ;
			int Max = 0;
			Line le = new Line();
		

			p1 = (Point)diffCorner1[indexOfCorner];
			p2 = (Point)diffCorner2[indexOfCorner];
		
			p.Color = Color.Black;
			g.DrawRectangle(p,p1.X,p1.Y,30,30);
			g.DrawRectangle(p,p2.X,p2.Y,30,30);  
			if(p1.X < p2.X)
				g.DrawLine(p,p1.X-50,p2.Y+50,p1.X+50,p2.Y-50);
			else
				g.DrawLine(p,p1.X-50,p2.Y-50,p1.X+50,p2.Y+50);

			le.addFirstPoint(p1.X+15,p1.Y+15);
			le.addLastPoint(p2.X+15,p2.Y+15);
		


				Max = 0;
			
			for(i = 0 ;i < oneSt.numberOfPoints();i++)
				{
					if(le.distancToPoint(oneSt.returnElement(i))  > Max)
					{
						Max = le.distancToPoint(oneSt.returnElement(i));
							p1 = oneSt.returnElement(i);
					}

				}
		
			
		//p.Color = Color.Blue;
		//g.DrawEllipse(p,p1.X-15,p1.Y-15,30,30);
		              	
		return p1;

		}
		
		public Recognizer returnRecognizer()
		{
			return r;
		}

		private void menuItem11_Click(object sender, System.EventArgs e)//Tools -> Draw Graph
		{
			Draw_graph dg = new Draw_graph();
			dg.Show();
			dg.inicialise(allSt);
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			this.changeDisplay();
			this.timer1.Stop();
		}

		private void menuItem12_Click(object sender, System.EventArgs e)  //Tools -> Draw Graph 2
		{
			Draw_graph_2 dg2 = new Draw_graph_2();
			dg2.Show();
			dg2.inicialise(allSt);
			dg2.inicialiseS(allSt);
		}

		private void markSquare(int distance)   //oznacimo kvadtatek
		{
			int i1,madMax=0;  //index kjer je najvecja verjetnost za kot
			for (i1=0; i1<oneSt.numberOfPoints();i1++)  //poiscemo max element in ga okvadratimo
				if (oneSt.returnRecognitionAll(i1)>oneSt.returnRecognitionAll(madMax) && oneSt.returnRecognitionAll(i1)<=1)
					madMax=i1;
            
			//System.Console.WriteLine("Najvecja vrednost je {0}",oneSt.returnRecognitionAll(madMax));
			if (!presentR) //prvic risemo
			{
				ugodnoS=oneSt.returnRecognitionAll(madMax);  //ta tocka bo trenutni kot (vrednost)
				presentR=true; //kvadratek je narisan
				ptR = oneSt.returnElement(madMax);
				p.Color=Color.Gold;
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				brn=madMax; //index novega kota
				p.Color=Color.FromName("Black");
			}
			else if (oneSt.returnRecognitionAll(madMax)>ugodnoS && oneSt.returnRecognitionAll(madMax)<=1)
			{	//nova najboljsa vrednost
				//ce najdemo boljse ujemanje, narisemo nov kvadratek in prejsnega zbrisemo

				ugodnoS=oneSt.returnRecognitionAll(madMax);
				p.Color=Color.FromName("White");
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				p.Color=Color.Black; //
				if (brn-10<0) i1=0;
				else i1=brn-10;

				for (int i=i1; (i<brn+10&&i<counter2-distance-1); i++)  //obnovimo prekinjeno krivuljo (counter je stevec pobranih tock)
					g.DrawLine(p,oneSt.returnElement(i),oneSt.returnElement(i+1));
                narisiObjekte1(); //ni nujno (za lepsi izris)

				brn=madMax; //nov index kvadratka
				ptR=oneSt.returnElement(brn);
				p.Color=Color.FromName("Gold");
				g.DrawRectangle(p,ptR.X-5,ptR.Y-5,10,10);
				p.Color=Color.FromName("Black");
			}

		} //markSquare

		public void calcR(Stroke1 oneSt) //izracunamo seznam pointRecognitionAll
		{
			double iRmax= 0,iSmax= 0;
			double zR,zS,zA;
			//int rr;
			//if (oneSt.numberOfPoints()-neighbor-1<0) rr=0;
			//else rr=oneSt.numberOfPoints()-neighbor-1;
            
			oneSt.clearPointRecognitionAll();

			for(int i = 0;i<oneSt.numberOfPoints();i++) //poberem max vrednosti (je treba gledat zmer cel interval)
			{                                           //ker imamo verjetnost kota
				if (oneSt.returnRecognitionSpeed(i)>iSmax) iSmax=oneSt.returnRecognitionSpeed(i);
				if (oneSt.returnRecognition(i)>iRmax) iRmax=oneSt.returnRecognition(i);
		    }
            //System.Console.WriteLine("Stevilo tock:{0}",oneSt.numberOfPoints());
			for(int i = 0;i<oneSt.numberOfPoints();i++) //izpolnim seznam 'pointRecognitionAll'
			{
				if (oneSt.returnRecognition(i)!=-2) zR=oneSt.returnRecognition(i)/iRmax;
				else zR=0;
                    
				if (oneSt.returnRecognitionAngle(i)!=-1) 
				{
					if (oneSt.returnRecognitionAngle(i)<=90) zA=oneSt.returnRecognitionAngle(i)/90;
					else zA=1-(oneSt.returnRecognitionAngle(i)-90)/90;
				}
				else zA=0;
                    
				if (oneSt.returnRecognitionSpeed(i)!=-1) zS=1-(oneSt.returnRecognitionSpeed(i)/iSmax);
				else zS=0;

				//System.Console.WriteLine("hitrost(0-1): {0}",zS);   

				oneSt.addRecognitionAll((zR+zS+zA)/3);
				//if (!(oneSt.returnRecognitionAll(i)==oneSt.returnRecognitionAll(i)))
				//	System.Console.WriteLine("zR:{0},zA:{1},zS:{2}",zR,zA,zS);
				

				//System.Console.WriteLine("sprotna:{0} od({1})",oneSt.returnRecognitionAll(i),i);
				
			} //for

		} //calcR

		public void chooseC(Point pMousePos,Point lastPoint) //fuckcija za radio button
		{
			if (radioButton3.Checked) 
			{
				markSquare(2);  //oznacimo tocko, ki je potencialni kot
				g.DrawLine(p,pMousePos,lastPoint);
			}
			else if (radioButton2.Checked) 
			{
				p.Width=7;
				for (int iC=0; iC < oneSt.numberOfPoints()-1;iC++) //sproti barvamo vnos
				{
					pMousePos=oneSt.returnElement(iC);
					lastPoint=oneSt.returnElement(iC+1);
					if (oneSt.returnRecognitionAll(iC+1)>=0 && oneSt.returnRecognitionAll(iC+1) <=1)
						p.Color=returnColor(oneSt.returnRecognitionAll(iC));
					else 
					{
						p.Color=Color.Black;
						//System.Console.WriteLine("Vrednost tocke {0} ni na intervalu (0,1)!!!",iC);
					}
					g.DrawLine(p,pMousePos,lastPoint);
				} //for
				p.Color=Color.Black;
				p.Width=2;
			}
			else if (radioButton1.Checked) 
				g.DrawLine(p,pMousePos,lastPoint);
			

		} //chooseC

		private void test_input_data_button_click(object sender, System.EventArgs e)
		{
			td = new Test_data();
			td.Show();
			td.SetLimit(sa); //poljemo zraven e atribute za kot
		} 
		
				
	}
	public class SetAttributes 
	{
		public double speed, angle, linearR;
         
    }
	
	 
}
