using System;
namespace symmetry
{
	
	/// <summary> Implements a viscosity/drag force to stabilize items.
	/// 
	/// </summary>
	/// <version>  1.0
	/// </version>
	/// <author>  <a href="http://jheer.org">Jeffrey Heer</a> prefuse(AT)jheer.org
	/// </author>
	public class DragForce:AbstractForce
	{
		override public bool ItemForce
		{
			get
			{
				return true;
			}
			//
			
		}
		override protected internal System.String[] ParameterNames
		{
			get
			{
				return pnames;
			}
			//
			
		}
		
		private static System.String[] pnames = new System.String[]{"DragCoefficient"};
		
		public const float DEFAULT_DRAG_COEFF = - 0.01f;
		public const int DRAG_COEFF = 0;
		
		public DragForce(float dragCoeff)
		{
			params_Renamed = new float[]{dragCoeff};
		} //
		
		public DragForce():this(DEFAULT_DRAG_COEFF)
		{
		} //
		
		/// <summary> Calculates the force vector acting on the given item.</summary>
		/// <param name="item">the ForceItem for which to compute the force
		/// </param>
		public override void  getForce(ForceItem item)
		{
			item.force[0] += params_Renamed[DRAG_COEFF] * item.velocity[0];
			item.force[1] += params_Renamed[DRAG_COEFF] * item.velocity[1];
		} //
	} // end of class DragForce
}