using System;
namespace symmetry
{
	
	/// <summary> Wrapper class for force simulation variables associated with a
	/// graph item instance.
	/// 
	/// </summary>
	/// <version>  1.0
	/// </version>
	/// <author>  <a href="http://jheer.org">Jeffrey Heer</a> prefuse(AT)jheer.org
	/// </author>
	public class ForceItem
	{
		public ForceItem()
		{
			mass = 1.0f;
			force = new float[]{0.0f, 0.0f};
			velocity = new float[]{0.0f, 0.0f};
			location = new float[]{0.0f, 0.0f};
			plocation = new float[]{0.0f, 0.0f};
			k = new float[4][];
			for (int i = 0; i < 4; i++)
			{
				k[i] = new float[2];
			}
			l = new float[4][];
			for (int i2 = 0; i2 < 4; i2++)
			{
				l[i2] = new float[2];
			}
		} //
		public float mass;
		public float[] force;
		public float[] velocity;
		public float[] location;
		public float[] plocation; // stores the previous location
		public float[][] k; // temp variables for Runge-Kutta integration
		public float[][] l; // temp variables for Runge-Kutta integration
	} // end of class ForceItem
}