using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace symmetry
{
	
	/// <summary> A Swing user interface component for configuring the parametes of the
	/// Force functions in the given ForceSimulator. Useful for exploring
	/// different parameterizations when crafting a visualization.
	/// 
	/// </summary>
	/// <version>  1.0
	/// </version>
	/// <author>  <a href="http://jheer.org">Jeffrey Heer</a> prefuse(AT)jheer.org
	/// </author>
	//UPGRADE_TODO: Class 'javax.swing.JPanel' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
	public class ForcePanel
	{
		private void  InitBlock()
		{
			action = new ForceConstantAction(this);
		}
		
		//UPGRADE_NOTE: The initialization of  'action' was moved to method 'InitBlock'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1005"'
		private ForceConstantAction action;
		private ForceSimulator fsim;
		
		public ForcePanel(ForceSimulator fsim)
		{
		//	InitBlock();
			this.fsim = fsim;
		//	this.setBackground(System.Drawing.Color.WHITE);
			initUI();
		} //
		
		private void  initUI(Graphics g,Pen p,Strokes1 strokes)
		{
			
			Force[] forces = fsim.Forces;
			for (int i = 0; i < forces.Length; i++)
			{
				Force f = forces[i];
				//UPGRADE_TODO: Class 'javax.swing.Box' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				//UPGRADE_TODO: Constructor 'javax.swing.Box.Box' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				//UPGRADE_TODO: Field 'javax.swing.BoxLayout.Y_AXIS' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				//Box v = new Box(BoxLayout.Y_AXIS);

				/*for (int j = 0; j < f.ParameterCount; j++)
				{
					//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
					v.Controls.Add(createField(f, j));
				}*/
				System.String name = f.GetType().FullName;
				name = name.Substring(name.LastIndexOf(".") + 1);
				//UPGRADE_TODO: Method 'javax.swing.BorderFactory.createTitledBorder' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			  //	v.setBorder(BorderFactory.createTitledBorder(name));
				//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			  //	this.Controls.Add(v);
			}
			//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			//UPGRADE_TODO: Method 'javax.swing.Box.createVerticalGlue' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
		//	this.Controls.Add(Box.createVerticalGlue());
		} //
		
		//UPGRADE_TODO: Class 'javax.swing.Box' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
		/*private Box createField(Force f, int param)
		{
			//UPGRADE_TODO: Class 'javax.swing.Box' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			//UPGRADE_TODO: Constructor 'javax.swing.Box.Box' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			//UPGRADE_TODO: Field 'javax.swing.BoxLayout.X_AXIS' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			Box h = new Box(BoxLayout.X_AXIS);
			
			float curVal = f.getParameter(param);
			
			//UPGRADE_TODO: Class 'javax.swing.JLabel' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			//UPGRADE_TODO: Constructor 'javax.swing.JLabel.JLabel' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			JLabel label = new JLabel(f.getParameterName(param));
			//UPGRADE_TODO: Method 'javax.swing.JComponent.setPreferredSize' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			label.setPreferredSize(new System.Drawing.Size(100, 20));
			//UPGRADE_TODO: Method 'javax.swing.JComponent.setMaximumSize' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			label.setMaximumSize(new System.Drawing.Size(100, 20));
			
			//UPGRADE_TODO: Class 'javax.swing.JTextField' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			//UPGRADE_TODO: Constructor 'javax.swing.JTextField.JTextField' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			JTextField text = new JTextField(curVal.ToString());
			//UPGRADE_TODO: Method 'javax.swing.JComponent.setPreferredSize' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			text.setPreferredSize(new System.Drawing.Size(200, 20));
			//UPGRADE_TODO: Method 'javax.swing.JComponent.setMaximumSize' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			text.setMaximumSize(new System.Drawing.Size(200, 20));
			//UPGRADE_TODO: Method 'javax.swing.JComponent.putClientProperty' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			text.putClientProperty("force", f);
			//UPGRADE_TODO: Method 'javax.swing.JComponent.putClientProperty' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			text.putClientProperty("param", (System.Object) (param));
			//UPGRADE_TODO: Method 'javax.swing.JTextField.addActionListener' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			text.addActionListener(action);
			//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			h.Controls.Add(label);
			//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			//UPGRADE_TODO: Method 'javax.swing.Box.createHorizontalStrut' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			h.Controls.Add(Box.createHorizontalStrut(10));
			//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			//UPGRADE_TODO: Method 'javax.swing.Box.createHorizontalGlue' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
			h.Controls.Add(Box.createHorizontalGlue());
			//UPGRADE_TODO: Method 'java.awt.Container.add' was converted to 'System.Windows.Forms.ContainerControl.Controls.Add' which has a different behavior. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1073"'
			h.Controls.Add(text);
			h.setPreferredSize(new System.Drawing.Size(300, 30));
			h.setMaximumSize(new System.Drawing.Size(300, 30));
			return h;
		} //
		*/
		//UPGRADE_TODO: Class 'javax.swing.AbstractAction' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
		//UPGRADE_NOTE: Field 'EnclosingInstance' was added to class 'ForceConstantAction' to access its enclosing instance. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1019"'
		private class ForceConstantAction
		{
			public ForceConstantAction(ForcePanel enclosingInstance)
			{
				InitBlock(enclosingInstance);
			}
			private void  InitBlock(ForcePanel enclosingInstance)
			{
				this.enclosingInstance = enclosingInstance;
			}
			private ForcePanel enclosingInstance;
			public ForcePanel Enclosing_Instance
			{
				get
				{
					return enclosingInstance;
				}
				
			}
	/*		public override void  actionPerformed(System.EventArgs arg0)
			{
				//UPGRADE_TODO: Class 'javax.swing.JTextField' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				//UPGRADE_NOTE: The method 'java.util.EventObject.getSource' needs to be in a event handling method in order to be properly converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1171"'
				JTextField text = (JTextField) arg0.getSource;
				//UPGRADE_TODO: Method 'javax.swing.text.JTextComponent.getText' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				float val = System.Single.Parse(text.getText());
				//UPGRADE_TODO: Method 'javax.swing.JComponent.getClientProperty' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				Force f = (Force) text.getClientProperty("force");
				//UPGRADE_TODO: Method 'javax.swing.JComponent.getClientProperty' was not converted. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1095"'
				System.Int32 param = (System.Int32) text.getClientProperty("param");
				f.setParameter(param, val);
			}
			*/
		} // end of inner class ForceAction
	} // end of class ForcePanel
}